#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum HTMLid{
    HTML_NINGUNO,
    HTML_BODY,
    HTML_cBODY,
    HTML_B,
    HTML_cB,
    HTML_HTML,
    HTML_cHTML,
    HTML_CENTER,
    HTML_cCENTER
};

void rollo(void);
static struct{
    char    *htmlcodigo;
    enum HTMLid id;
}
lista_de_codigos[]={
    {"<HTML>",      HTML_HTML},
    {"</HTML>",     HTML_cHTML},
    {"<BODY>",      HTML_BODY},
    {"</BODY>",     HTML_cBODY},
    {"<CENTER>",    HTML_CENTER},
    {"</CENTER>",   HTML_cCENTER},
    {"<B>",         HTML_B},
    {"</B>",        HTML_cB},
    {NULL,          HTML_NINGUNO}
};

char        texto[128];
int         itexto=0, c;
int main(){
    int             i, ietiqueta=0;
    char            etiqueta[64];
    FILE            *archivo;
    enum HTMLid     codigo;

    archivo = fopen("Prueba.html", "r"); /* Abre el archivo para lectura */

    if (archivo == NULL){
        printf("El archivo no existe...\n");
        exit (EXIT_FAILURE);
    }else{
        do{      /* Checa todos los caracteres del archivo */
            c=getc(archivo);
            if (c=='<'){     /* Lee la etiqueta html */
                /* incluye el principio de la etiqueta */
                etiqueta[ietiqueta++]=c;
                do{
                    c=getc(archivo);
                    etiqueta[ietiqueta++]=c;
                }
                while(c!='>');
                etiqueta[ietiqueta]=0;
                codigo=HTML_NINGUNO;
                for(i=0; lista_de_codigos[i].htmlcodigo!=NULL; i++)
                {
                    if(stricmp(etiqueta,
                      lista_de_codigos[i].htmlcodigo)==0)
                    {
                        codigo=lista_de_codigos[i].id;
                        break;
                    }
                }
                switch (codigo)
                {
                    case HTML_NINGUNO:
                    break;
                    case HTML_HTML:
                    printf("Empieza el documento web \n");
                    break;
                    case HTML_cHTML:
                    printf("Fin del documento web \n");
                    break;
                    case HTML_B:
                    printf("Empieza la etiqueta B \n");
                    break;
                    case HTML_cB:
                    printf("Termina la etiqueta B \n");
                    break;
                    case HTML_BODY:
                    printf("Empieza la etiqueta BODY \n");
                    break;
                    case HTML_cBODY:
                    printf("Termina la etiqueta BODY \n");
                    break;
                    case HTML_CENTER:
                    printf("Empieza la etiqueta CENTER \n");
                    break;
                    case HTML_cCENTER:
                    printf("Termina la etiqueta CENTER \n");
                    break;
                }
                ietiqueta=0;
            }
            else
            rollo();
        }
        while(c!=EOF);
    }
    fclose(archivo);
    texto[itexto]=0;
    printf(texto);
    return EXIT_SUCCESS;
}

void rollo(void)
{
    texto[itexto++]=c;
}

